#include <iostream>
#include <memory>

class Base {
public:
	virtual void f() const { std::cout << "Base::f()\n"; }
};

class Derived : public Base {
public:
	void f() const override { std::cout << "Derived::f()\n"; }
};

int main() {
	Derived d;
	d.f();
	Base& ref = d;
	ref.f();
	Base* ptr = &d;
	ptr->f();

	std::unique_ptr<Base> uptr = std::make_unique<Derived>();
	uptr->f();
}
