#include <iostream>

class Base {
public:
	virtual void sayHello() const { std::cout << "Base says hello.\n"; }
	virtual ~Base() = default;
};

class Derived : public Base {
	std::string secret = "Only Derived can do this!\n";

public:
	void sayHello() const override { std::cout << "Derived says hello.\n"; }
	void doSomethingOnlyDerivedCan() const {
		std::cout << secret;
	}
};

int main() {
	Base b;
	Derived d;

	Base* ptr = &d; // try using &b here

	// Derived* ptrD = ptr; // this doesn't work
	auto* ptrD = dynamic_cast<Derived*>(ptr);
	if (ptrD) {
		ptrD->doSomethingOnlyDerivedCan();
	} else {
		std::cout << "dynamic cast was not succesful :-(\n";
	}

	Base& ref = d; // try using b here

	auto& refD = dynamic_cast<Derived&>(ref);
	refD.doSomethingOnlyDerivedCan();
}
